Option Explicit

Function Betterscore% (tim%, piec%, siz%, scoreno%, Score%, Pieces%, Rows%, Cols%)
'return true if we just score a better score
If (scoreno <= Max_No_High_Scores) Then
  If High_Score(tim, piec, siz, scoreno) = Score Then
    If High_Pieces(tim, piec, siz, scoreno) = Pieces Then
	If High_Rows(tim, piec, siz, scoreno) + High_Cols(tim, piec, siz, scoreno) = Rows + Cols Then
	    Betterscore = min(Rows, Cols) < min(High_Rows(tim, piec, siz, scoreno), High_Cols(tim, piec, siz, scoreno))
	Else
	    Betterscore = Rows + Cols > High_Rows(tim, piec, siz, scoreno) + High_Cols(tim, piec, siz, scoreno)
	End If
    Else
	Betterscore = Pieces > High_Pieces(tim, piec, siz, scoreno)
    End If
  Else
      Betterscore = Score > High_Score(tim, piec, siz, scoreno)
  End If
End If
End Function

Sub Load_High_Score_File ()
Dim i%, t%, p%, size%, scores$()
ReDim scores$(Max_No_High_Scores)
    Open HISCORE_FILE For Input Access Read As #1
    For t = 1 To 2
	For p = 1 To 3
	    For size = 1 To 4
		For i = 1 To Max_No_High_Scores
		    Input #1, High_Score(t, p, size, i)
		    Input #1, High_Pieces(t, p, size, i)
		    Input #1, High_Cols(t, p, size, i)
		    Input #1, High_Rows(t, p, size, i)
		    Input #1, High_Name(t, p, size, i)
		Next i
	    Next size
	Next p
    Next t
    Close   ' Close all files.
End Sub

Sub New_High_Score (Score%, Pieces%, Cols%, Rows%)
Dim scoreno%, i%
    scoreno = 1
    While Not (Betterscore(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, scoreno, Score%, Pieces%, Rows%, Cols%)) And (scoreno <= Max_No_High_Scores)
	scoreno = scoreno + 1
    Wend
    If (scoreno <= Max_No_High_Scores) Then
	For i = Max_No_High_Scores To scoreno + 1 Step -1
	    High_Score(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i) = High_Score(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i - 1)
	    High_Cols(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i) = High_Cols(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i - 1)
	    High_Rows(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i) = High_Rows(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i - 1)
	Next i
	High_Score(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, scoreno) = Score
	High_Pieces(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, scoreno) = Pieces
	High_Cols(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, scoreno) = Cols
	High_Rows(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, scoreno) = Rows
	High_Score_Number = scoreno
	Hi_Score_Input.Show
	'High_Name(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, ScoreNo) = Hi_Score_Input.Text1.Text
	Call Save_High_Score_File
    End If
End Sub

Sub Print_High_Scores ()
Dim i%
    For i = 1 To Max_No_High_Scores
	High_Score_Form.Score_Label(i + 56).Caption = CStr(High_Score(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i))
	High_Score_Form.Score_Label(i + 14).Caption = CStr(High_Pieces(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i))
	High_Score_Form.Score_Label(i + 42).Caption = CStr(High_Cols(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i))
	High_Score_Form.Score_Label(i + 28).Caption = CStr(High_Rows(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i))
	High_Score_Form.Score_Label(i).Caption = High_Name(1 + Timed, The_Grid.Piece_Set - 3, The_Grid.size - 4, i)
    Next i
    High_Score_Form.Show 1
End Sub

Sub Save_High_Score_File ()
Dim i%, t%, p%, size%, scores$()
ReDim scores$(Max_No_High_Scores)
    'Save the Hiscores
    Open HISCORE_FILE For Output Access Write Lock Write As #1
    For t% = 1 To 2
	For p% = 1 To 3
	    For size = 1 To 4
		For i = 1 To Max_No_High_Scores
		    Print #1, High_Score(t, p, size, i)
		    Print #1, High_Pieces(t, p, size, i)
		    Print #1, High_Cols(t, p, size, i)
		    Print #1, High_Rows(t, p, size, i)
		    Print #1, High_Name(t, p, size, i)
		Next i
	    Next size
	Next p
    Next t
    Close   ' Close all files.
End Sub
    

